import java.util.ArrayList;
import java.util.List;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;

public class ConsumerUsage {
    public static void main(String args[]){


            List<String> cities = new ArrayList<>();
            cities.add("Delhi");
            cities.add("Mumbai");
            cities.add("Goa");
            cities.add("Pune");

            Consumer<String> printConsumer= city-> System.out.println(city);
            cities.forEach(printConsumer);
            cities.forEach(System.out::println);

            // predicate
            System.out.println("**** test predicate");
            Predicate<String> filterCity = city -> city.equals("Mumbai");
            cities.stream().filter(filterCity).forEach(System.out::println);
            cities.stream().filter(c->c.equalsIgnoreCase("Pune")).forEach(System.out::println);

            // function
        System.out.println("**** test function");
        Function<String, Character> getFirstCharFunction = city -> {
            return city.charAt(0);
        };
        cities.stream().map(getFirstCharFunction)
                .forEach(System.out::println);
        //cities.stream().map(city->city.charAt(0)).forEach(System.out::println);
        }

}
