import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

import static java.util.Map.Entry.comparingByValue;
import static java.util.stream.Collectors.toMap;

public class TestSoryByKey {
    public static void main(String args[]){

        HashMap<String, Integer> map = new HashMap();
        map.put("java",233);
        map.put("spring",233);
        map.put("springboot",231);
        map.put("UI",123);

        HashMap<String,Integer> sortedMap = map.entrySet().stream().
                sorted((i1,i2)
                         ->i1.getKey().compareTo(i2.getKey())).
                collect(toMap(Map.Entry::getKey,
                         Map.Entry::getValue,
                          (e1, e2) -> e1, LinkedHashMap::new));

        System.out.println("Sorted Map:"+sortedMap);

        HashMap<String, Integer> map2 = new HashMap();
        map2.put("java",23);
        map2.put("spring",233);
        map2.put("springboot",231);
        Map<String, Integer> sorted = map2
                .entrySet()
                .stream()
                .sorted(comparingByValue())
                .collect(toMap(Map.Entry::getKey,
                         Map.Entry::getValue,
                         (e1, e2) -> e1, LinkedHashMap::new));
        System.out.println("Sort by Value: "+sorted);

        Map<String,Integer> reverseOrder = map2
                .entrySet()
                .stream()
                .sorted(Collections.reverseOrder(Map.Entry.comparingByValue()))
                .collect(toMap(Map.Entry::getKey,
                        Map.Entry::getValue,
                        (e1, e2) -> e1, LinkedHashMap::new));
        System.out.println("Sort by value in reverse Order: "+reverseOrder);

        System.out.println(sortedMap);

    }
}
